Subject: RE: [Fwd: use ideas from, but not true aal]

From: Yaakov Stein <[email-masked]>
Date: Tue, 16 Apr 2002 09:10:57 +0300

Craig, 
 
I fully agree with a lot that you have said,
and would really like to help you improve your resume.
 
However, let me, once again, clarify what is involved in what you call
"AAL1-specific complexity that ought to be eliminated".
I think this will also explain what I meant by "leaving the bits alone".
 
Think of the incoming trunk as a stream of bytes.
 
If this stream is unstructured, i.e. has no natural boundaries,
then I agree (and have proposed in my proposal at Minneapolis and to the
list)
that we leave it alone. That is segment it in whatever way seems natural
(100 bytes per packet, 256 bytes, whatever seems right to you).
 
However, sometimes this stream has natural boundaries, 
which may happen to be every 24 bytes, or every 32 bytes, 
or every 188 bytes, or every 512 byte, or every 576 bytes, or whatever.
In this case every N bytes we insert a pointer to the next
"start of structure" byte.
 
Now, this N can not be completely arbitrary, since a single byte can only 
represent 256 different offsets. What AAL1 does is slightly tricky, but
worth the effort.
It protects the pointer with a even parity bit so has only 7 bits to work
with.
You might think that this means that we have to introduce it once every 128
bytes,
but by not always introducing it at exactly the same place,
we can get away with using it only every 375 input stream bytes.
If the structure is larger than this a pointers will take the special value
127
and the next pointer will contain the structure start offset.
 
The reason behind all this trickiness was the desire of the AAL1 designers
to be as efficient as possible. They counted every byte and came up with
the tightest possible arangement. This stinginess is built into the ATM
mentality.
 
IETF standards are not required to hold bandwidth efficiency above all else,
and so if AAL1 had never been invented I probably would not have expended 
the effort to come up with such a efficient protocol.
 
However, IETF WGs ARE required to re-use existing, time-proven, standards
as much as possible. AAL1 is a mature standard that has been proven to work
in the real-world.
 
In addition, adhering to AAL1 allows us to service interwork with existing 
"ATM pseudo-wires". 
 
And even more important, adherence to the AAL framework
enables us to drop in AAL2 whenever we need dynamic allocation.
 
For these reasons it does not make sense to arbitrarily create another
standard
just in order to be different (and less efficient).
 
Backing an existing protocol may be less impressive on your resume,
but I bet your boss would like that fact that you can take well-known
methods
and have a rock-solid system working in the field without problems
in short order. By backing TDMoIP not only won't you need to prepare a
resume
you may even get promoted :) .
 
Y(J)S